#    Police Operation Garden Exhibition
#    Copyright (C) 2016  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
pygame.init()


class HairCross( pygame.sprite.Sprite ):
	"""This class represents a hair cross which the player can use to aim at
	things.

	"""
	def __init__( self, _settings ):
		"""This function initialises the object.

		"""
		super( HairCross, self ).__init__()
		
		# Save settings for a possible later use.
		self.settings = _settings

		# Initialise the variables / object here.
		self.init_hair_cross()


	def init_hair_cross( self ):
		"""This function initialises the hair cross so it can be drawn onto the
		main game window.

		"""
		self.image = pygame.Surface( self.settings["dimensions"] )
		self.image.set_colorkey( self.settings["background_colour"] )

		for line in ( self.settings["horizontal_line"],
					  self.settings["vertical_line"] ):

			pygame.draw.line( self.image,
							  self.settings["colour"],
							  line["start_pos"],
							  line["end_pos"],
							  line["width"] )

		self.rect = self.image.get_rect()


	def update( self ):
		"""Updates the position of the hair cross.

		"""
		self.rect.center = pygame.mouse.get_pos()
