#    Police Operation Garden Exhibition
#    Copyright (C) 2016  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os.path

import pygame
pygame.init()

from code.modules import loading


class InfoPanel( pygame.sprite.Sprite ):
	"""

	"""
	def __init__( self, _settings ):
		"""

		"""
		super( InfoPanel, self ).__init__()

		self.settings = _settings

		self.image = pygame.Surface( self.settings["size"] )
		self.image.fill( self.settings["background_colour"] )
		self.rect = self.image.get_rect()
		self.rect.topleft = self.settings["position_left_top"]

		pygame.draw.lines( self.image,
						   self.settings["border_colour"],
						   True,
						   self.settings["border_points"],
						   self.settings["border_width"] )


		self.font_heading = loading.load_font(
			os.path.join(
				self.settings["fonts"]["font_heading"]["font_dir"],
				self.settings["fonts"]["font_heading"]["font_name"]
			),
			self.settings["fonts"]["font_heading"]["font_size"]			
		)

		self.font_normal = loading.load_font(
			os.path.join(
				self.settings["fonts"]["font_normal"]["font_dir"],
				self.settings["fonts"]["font_normal"]["font_name"]
			),
			self.settings["fonts"]["font_normal"]["font_size"]			
		)

		self.font_small = loading.load_font(
			os.path.join(
				self.settings["fonts"]["font_small"]["font_dir"],
				self.settings["fonts"]["font_small"]["font_name"]
			),
			self.settings["fonts"]["font_small"]["font_size"]		
		)

		self.texts = pygame.sprite.Group()
		for text in self.settings["texts"]:
			if self.settings["texts"][text]["size"] == "heading":
				font_to_use = self.font_heading
				font_to_use.set_underline( True )
			elif self.settings["texts"][text]["size"] == "normal":
				font_to_use = self.font_normal				
			elif self.settings["texts"][text]["size"] == "small":
				font_to_use = self.font_small
				
			txt = pygame.sprite.Sprite()
			txt.image = font_to_use.render(
				self.settings["texts"][text]["text"],
				True,
				self.settings["texts"][text]["colour"]
			)
			txt.rect = txt.image.get_rect()
			txt.rect.topleft = self.settings["texts"][text]["pos"]

			self.texts.add( txt )


		self.left_click_modes = self.settings["left_click_modes"]
		self.left_click_mode = self.left_click_modes[0]

		# left click mode
		self.left_click_mode_txt = pygame.sprite.Sprite()
		self.left_click_mode_txt.image = self.font_small.render(
				self.left_click_mode,
				True,
				self.settings["left_click"]["colour"]
			)
		self.left_click_mode_txt.rect = self.left_click_mode_txt.image.get_rect()
		self.left_click_mode_txt.rect.topleft = self.settings["left_click"]["pos"]
		self.texts.add( self.left_click_mode_txt )

		# score
		self.score = 0
		self.score_str = str( self.score )
		self.score_txt = pygame.sprite.Sprite()
		self.score_txt.image = self.font_small.render(
			self.score_str,
			True,
			self.settings["score"]["colour"]
		)
		self.score_txt.rect = self.score_txt.image.get_rect()
		self.score_txt.rect.topleft = self.settings["score"]["pos"]
		self.texts.add( self.score_txt )

		# faulty ones
		self.faulty_ones = 0
		self.faulty_ones_str = str( self.score )
		self.faulty_ones_txt = pygame.sprite.Sprite()
		self.faulty_ones_txt.image = self.font_small.render(
			self.faulty_ones_str,
			True,
			self.settings["faulty_ones"]["colour"]
		)
		self.faulty_ones_txt.rect = self.faulty_ones_txt.image.get_rect()
		self.faulty_ones_txt.rect.topleft = self.settings["faulty_ones"]["pos"]
		self.texts.add( self.faulty_ones_txt )	

		# acci_hit
		self.acci_hit = 0
		self.acci_hit_str = str( self.score )
		self.acci_hit_txt = pygame.sprite.Sprite()
		self.acci_hit_txt.image = self.font_small.render(
			self.acci_hit_str,
			True,
			self.settings["acci_hit"]["colour"]
		)
		self.acci_hit_txt.rect = self.acci_hit_txt.image.get_rect()
		self.acci_hit_txt.rect.topleft = self.settings["acci_hit"]["pos"]
		self.texts.add( self.acci_hit_txt )	

		# rob_fix	
		self.rob_fix = 0
		self.rob_fix_str = str( self.score )
		self.rob_fix_txt = pygame.sprite.Sprite()
		self.rob_fix_txt.image = self.font_small.render(
			self.rob_fix_str,
			True,
			self.settings["rob_fix"]["colour"]
		)
		self.rob_fix_txt.rect = self.rob_fix_txt.image.get_rect()
		self.rob_fix_txt.rect.topleft = self.settings["rob_fix"]["pos"]
		self.texts.add( self.rob_fix_txt )					


		self.texts.draw( self.image )	


	def update( self, _player_score, _player_mode, _player_faulty_ones,
					_player_acci_hit, _player_rob_fix ):
		"""

		"""
		if _player_score != self.score:
			self.score = _player_score
			self.update_txt( self.score_txt, str( self.score ), self.settings["score"] )

		if _player_mode != self.left_click_mode:
			self.left_click_mode = _player_mode
			self.update_txt( self.left_click_mode_txt, self.left_click_mode, self.settings["left_click"] )

		if _player_faulty_ones != self.faulty_ones:
			self.faulty_ones = _player_faulty_ones
			self.update_txt( self.faulty_ones_txt, str( self.faulty_ones ), self.settings["faulty_ones"] )

		if _player_acci_hit != self.acci_hit:
			self.acci_hit = _player_acci_hit
			self.update_txt( self.acci_hit_txt, str( self.acci_hit ), self.settings["acci_hit"] )

		if _player_rob_fix != self.rob_fix:
			self.rob_fix = _player_rob_fix
			self.update_txt( self.rob_fix_txt, str( self.rob_fix ), self.settings["rob_fix"] )									

		self.image.fill( self.settings["background_colour"] )
		self.texts.draw( self.image )


	def update_txt( self, _control, _new_text, _settings ):
		"""

		"""
		_control.image = self.font_small.render(
			_new_text,
			True,
			_settings["colour"]
		)
		_control.rect = _control.image.get_rect()
		_control.rect.topleft = _settings["pos"]		
