#    Police Operation Garden Exhibition
#    Copyright (C) 2016  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
import os
import pygame
from code.settings import settings
from code.classes.Game import Game

pygame.init()
pygame.mixer.pre_init(frequency=22050, size=-16, channels=2, buffer=8192)


def main():
	"""Entry point of the game.

	"""
	print os.getcwd()
	pygame.mixer.music.load( os.path.join( os.getcwd(), "music", "music_for_pyweek22.ogg" ) )
	pygame.mixer.music.play( -1 )
	
	game = Game( settings.GAME_WINDOW,
				 settings.GAME_CLOCK,
				 settings.GAME_CURSOR,
				 settings.HAIR_CROSS,
				 settings.VISITOR_SETTINGS,
				 settings.AREA_SETTINGS,
				 settings.PLAYER_SETTINGS )

	game.run_menu()


# Runs the game.
main()
